package oliot.aika.olio;

/**
 * @author vesal
 * @version 13.2.2024
 */
public interface AikaRajapinta {

    /**
     * Lisää aikaan valitun minuuttimäärän
     * @param lisaMin lisättävä minuuttimäärä
     * @example
     * <pre name="test">
     *  Aika a1 = new Aika(13,16);
     *  a1.lisaa(27);    a1.toString() === "13:43";
     *  a1.lisaa(39);    a1.toString() === "14:22";
     * </pre>
     */
    void lisaa(int lisaMin);


    /**
     * @return aika merkkijonona muodossa 12:05
     * @example
     * <pre name="test">
     * new Aika(7,5).toString() === "07:05";
     * new Aika(12,15).toString() === "12:15";
     * </pre>
     */
    @Override
    String toString();

}