package fxKerho;

import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.ModalControllerInterface;
import javafx.stage.Stage;
import javafx.fxml.FXML;
import javafx.scene.control.TextField;

/**
 * Kystään kerhon nimi ja luodaan tätä varten dialogi.
 * 
 * @author vesal
 * @version 2.1.2016
 */
public class KerhonNimiController  implements ModalControllerInterface<String> {

    
    /**
     * Luodaan nimenkysymisdialogi ja palautetaan siihen kirjoitettu nimi tai null
     * @param modalityStage mille ollaan modaalisia, null = sovellukselle
     * @param oletus mitä nimeä näytetään oletuksena
     * @return null jos painetaan Cancel, muuten kirjoitettu nimi
     */
    public static String kysyNimi(Stage modalityStage, String oletus) {
        return ModalController.showModal(
           KerhonNimiController.class.getResource("KerhonNimiView.fxml"),
                     "Kerho",
                     modalityStage, oletus);
        }

    @Override
    public String getResult() {
        return vastaus;
    }

    @FXML private TextField textVastaus;
    private String vastaus = null;

    
    @FXML private void handleOK() {
        vastaus = textVastaus.getText();
        ModalController.closeStage(textVastaus);
    }

    
    @FXML private void handleCancel() {
        ModalController.closeStage(textVastaus);
    }

    @Override
    public void setDefault(String oletus) {
        textVastaus.setText(oletus);
    }

    @Override
    public void handleShown() {
        textVastaus.requestFocus();
    }


}
