package fxKerho;

import java.io.PrintStream;
import java.net.URL;
import java.util.ResourceBundle;

import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ListChooser;
import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.TextAreaOutputStream;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.ScrollPane;
import javafx.scene.control.TextArea;
import javafx.scene.text.Font;
import kerho.Jasen;
import kerho.Kerho;
import kerho.SailoException;

/**
 * @author vesal
 * @version 31.12.2015
 * Luokka käyttöliittymän tapahtumien hoitamiseksi
 */
public class KerhoGUIController implements Initializable{

    @FXML private ListChooser<Jasen> chooserJasenet;
    @FXML private ScrollPane panelJasen;
    
    /**
     * Käsitellään uuden jäsenen lisääminen
     */
    @FXML private void handleUusiJasen() {
        // Dialogs.showMessageDialog("Ei osata vielä lisätä");
        // Dialogs.showMessageDialog("Tiedosto kelmit/nimet.dat ei aukea");
        // Dialogs.showQuestionDialog("Poisto?", "Poistetaanko jäsen: Hopo Hessu", "Kyllä", "Ei");
        uusiJasen();
    }

    @FXML private void handleMuokkaaJasen() {
        // TODO: vaihe 5-7
        ModalController.showModal(KerhoGUIController.class.getResource("JasenDialogView.fxml"), "Jäsen", null, "");
    }

    
    @Override
    public void initialize(URL arg0, ResourceBundle arg1) {
        alusta();
    }
    
    
    
 // ===========================================================================================
    private Kerho kerho;
    private TextArea areaJasen = new TextArea(); 
    
    
    private void alusta() {
        panelJasen.setContent(areaJasen);
        areaJasen.setFont(new Font("Courier New", 12)); 
        panelJasen.setFitToHeight(true);
        chooserJasenet.clear();
        chooserJasenet.addSelectionListener(e -> naytaJasen());
    }
    
    
    private void lueTiedosto(String nimi) {
        // kerhonnimi = nimi;
        // setTitle("Kerho - " + nimi);
        String virhe = "Ei osata lukea vielä " + nimi;  // TODO: tähän oikea tiedoston lukeminen
        // if (virhe != null) 
            Dialogs.showMessageDialog(virhe);
    }
    
    
    /**
     * @return true jos avattin false jos painettiin Cancel
     */
    public boolean avaa() {
        String uusinimi = KerhonNimiController.kysyNimi(null, "kelmit");
        if (uusinimi == null) return false;
        lueTiedosto(uusinimi);
        return true;
    }

    
    /**
     * Asettaa käytettävän kerho
     * @param kerho jota käytetään
     */
    public void setKerho(Kerho kerho) {
       this.kerho = kerho; 
    }

    
    private void hae(int jnro) {
        chooserJasenet.clear();
        
        int index = 0;
        for (int i=0; i < kerho.getJasenia(); i++) {
            Jasen jasen = kerho.annaJasen(i);
            if (jasen.getTunnusNro() == jnro) index = i;
            chooserJasenet.add(jasen.getNimi(), jasen);
        }
        chooserJasenet.setSelectedIndex(index);
    }
    
    

    /**
     * Lisätään kerhoon uusi jäsen
     */
    private void uusiJasen() {
        Jasen uusi = new Jasen();
        uusi.vastaaAkuAnkka();
        uusi.rekisteroi();
        try {
            kerho.lisaa(uusi);
        } catch (SailoException e) {
            Dialogs.showMessageDialog("Ongelmia uuden luomisessa " + e.getMessage());
        }
        hae(uusi.getTunnusNro());
    }


    private void naytaJasen() {
        Jasen jasenKohdalla = chooserJasenet.getSelectedObject();
    
        if (jasenKohdalla == null) return;
    
        areaJasen.setText("");
        try (PrintStream os = TextAreaOutputStream.getTextPrintStream(areaJasen)) {
            jasenKohdalla.tulosta(os);
        }    
    }
    
    
}
