package kerho;

/**
 * CRC sisällöt tähän
 * @author vesal
 * @version 23.2.2021
 */
public class Kerho {
    
    private Jasenet jasenet = new Jasenet();
    
    /**
     * Alustaa kerhon tiedot
     */
    public Kerho() {
        // ei tarvii vielä mitään
    }

    
    /**
     * Lisää uuden jäsenen
     * @param jasen lisättävä jäsen
     * @throws SailoException jos ei mahu
     */
    public void lisaa(Jasen jasen) throws SailoException {
        jasenet.lisaa(jasen);
    }
    
    
    /**
     * @return jäsenten lkm
     */
    public int getJasenia() {
        return jasenet.getLkm();
    }
  
    
    /**
     * Antaa kerhon i:n jäsenen
     * @param i monesko jäsen (alkaa 0:sta)
     * @return jäsen paikasta i
     * TODO: laitetaanko indexOutOfBounds-poikkeus näkyville
     */
    public Jasen annaJasen(int i) {
        return jasenet.anna(i);
    }
  
    
    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        Kerho kerho = new Kerho();
        
        Jasen aku = new Jasen();
        Jasen aku2 = new Jasen();
        aku.rekisteroi();
        aku.vastaaAkuAnkka();     
        aku2.rekisteroi();
        aku2.vastaaAkuAnkka();    

        try {
            kerho.lisaa(aku);
            kerho.lisaa(aku2);
        } catch (SailoException e) {
            // e.printStackTrace();
            System.err.println(e.getMessage());
        }

        for (int i=0; i<kerho.getJasenia(); i++) {
            Jasen jasen = kerho.annaJasen(i);
            jasen.tulosta(System.out);;
        }

    }

}
