package taulukot;

import java.util.Arrays;

/**
 * Tutkaillaan taulukoita
 * @author vesal
 * @version 26.2.2024
 */
public class Kuut1 {
    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
                                 //   0   1   2   3
        int[] kPituudet = new int[]{ 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
        System.out.println(Arrays.toString(kPituudet));
        kPituudet[1] = 29;
        
        int summa = 0;
        for (int i = 0; i < kPituudet.length; i++) {
            int alkio = kPituudet[i];
            summa += alkio;
        }
        System.out.println(summa);
        
        summa = 0;
        for (int alkio: kPituudet) {
            summa += alkio;
        }
        System.out.println(summa);
        
        int[] t = new int[10];
        alusta(t, 2, 7);
        System.out.println(Arrays.toString(t));
    }
    
    
    /**
     * Alustetaan taulukko juoksevasti
     * @param t alustettava taulukko
     * @param alku mikä ekan paikan arvoksi
     * @param askel minkä verran seuraa on isompi
     * <pre name="test">
     * #import java.util.Arrays;
     *    int[] t = new int[5];
     *    Arrays.toString(t) === "[0, 0, 0, 0, 0]";
     *    alusta(t,3,5);
     *    Arrays.toString(t) === "[3, 8, 13, 18, 23]";
     *    Arrays.toString(alusta(new int[0],1,1)) === "[]";
     *    Arrays.toString(alusta(new int[1],1,1)) === "[1]";
     *    Arrays.toString(alusta(new int[3],1,-1)) === "[1, 0, -1]";
     *    Arrays.toString(alusta(new int[]{1,2},3,2)) === "[3, 5]";
     * </pre>
     * 
     * <pre name="test">
     *    Arrays.toString(alusta(new int[$koko],$alku,$askel)) === "$tulos";
     *    
     *        $koko | $alku | $askel | $tulos
     *     ----------------------------------------------------   
     *         5    |  3    |   5    | [3, 8, 13, 18, 23]   
     *         0    |  1    |   1    | []         
     *         1    |  1    |   1    | [1]         
     *         3    |  1    |  -1    | [1, 0, -1]         
       * </pre>
     * 
     * @return viitteen alustamaansa taulukkoon
     */
    public static int[] alusta(int[] t, int alku, int askel) {
        int arvo = alku;
        for (int i = 0; i < t.length; i++) {
            t[i] = arvo;
            arvo += askel;             
        }
        return t;
    }     
}

