package testaaminen;

import static testaaminen.Poista.poista;
import static org.junit.Assert.assertEquals;

import org.junit.Test;

/**
 * Testataan Poista-luokan metodeja
 * <pre>
 *  1) Ollaan aluksi testattavan luokan kohdalla
 *  2) File/New/JUnit Test Case
 *  3) Ruksitaan tarvittaessa setUp() (alustus ennen testejä)
 *     ja tearDown() (testien jälkeen tehtävät operaatiot)
 *     Näihin voi kuulua esim. olioiden luomista ja vapauttamista.
 *     Tarkista että on JUnit 4
 *  4) Next
 *  5) Ruksitaan metodit jotka halutaan testata.
 *     Jos joku jää ruksaamatta, niin ei hätää, testejä on
 *     helppo lisätä käsinkin
 *  6) Finish
 *  7) Täydennetään testitapaukset
 *  8) Aja hiiren oikealla ja Run As/JUnit Test
 * </pre>
 * 
 * @author vesal
 *
 */
public class PoistaTest {

    /** Testaan poistamista */
    @SuppressWarnings("static-method")
    @Test
    public void testPoista() {
        assertEquals("Selkeä","Cc", poista("Catcat","at"));
        assertEquals("Poistaminen tuottaa uuden","Pi", poista("Paatti","at"));
        assertEquals("Perusversio","Puit", poista("Puatit","at"));
        assertEquals("Poistaminen tuotata uusia","Abb", poista("Abbababba","ba"));
        assertEquals("Poistettavaa ei löydy","Abba", poista("Abba","Aa"));
    }

}
