package luento15;

/**
 * Tutkitaan jonoksi-funktion suorituskykyä
 * @author vesal
 * @version 25.2.2018
 *
 */
public class Jonoksi {


    /**
     * Palautetaan taulukko merkkijonona erottimella eroteltuna.
     * Lopussa ei ylimääräistä erotinta.
     * Toteutus käyttämällä String.format.
     * @param taulukko joka palautetaan jonona
     * @param erotin millä jonolla erotellaan
     * @param tila monenko merkin tila kullekin numerolle varataan.
     * @return taulukko merkkijonona erottimella eroteltuna
     * @example
     * <pre name="test">
     *   int[] t = {1,2,13,4};
     *   jonoksi(t,",",1) === "1,2,13,4";
     *   jonoksi(t,",",2) === " 1, 2,13, 4";
     * </pre>
     */
    public static String jonoksi(int[] taulukko,String erotin,int tila) {
        StringBuilder tulos = new StringBuilder();
        String format = String.format("%%s%%%dd", tila); // esim. %s%2d
        String ero = "";
        for (int  luku : taulukko) {
            tulos.append(String.format(format,ero,luku));
            ero = erotin;
        }
        return tulos.toString();
    }


    /**
     * Palautetaan taulukko merkkijonona erottimella eroteltuna.
     * Lopussa ei ylimääräistä erotinta.
     * Toteutus aloittamalla tyhjällä erottimella.
     * @param taulukko joka palautetaan jonona
     * @param erotin millä jonolla erotellaan
     * @return taulukko merkkijonona erottimella eroteltuna
     * @example
     * <pre name="test">
     *   int[] t = {1,2,13,4};
     *   jonoksi(t,",") === "1,2,13,4";
     * </pre>
     */
    public static String jonoksi(int[] taulukko,String erotin) {
        StringBuilder tulos = new StringBuilder();
        String ero = "";
        for (int  luku : taulukko) {
            tulos.append(ero);
            tulos.append(luku);
            ero = erotin;
        }
        return tulos.toString();
    }


    /**
     * Palautetaan taulukko merkkijonona erottimella eroteltuna.
     * Lopussa ei ylimääräistä erotinta.
     * Toteutus liittämällä ensin erotin ja luku.
     * @param taulukko joka palautetaan jonona
     * @param erotin millä jonolla erotellaan
     * @return taulukko merkkijonona erottimella eroteltuna
     * @example
     * <pre name="test">
     *   int[] t = {1,2,13,4};
     *   jonoksi2(t,",") === "1,2,13,4";
     * </pre>
     */
    public static String jonoksi2(int[] taulukko,String erotin) {
        StringBuilder tulos = new StringBuilder();
        String ero = "";
        for (int  luku : taulukko) {
            tulos.append(ero + luku);
            ero = erotin;
        }
        return tulos.toString();
    }


    /**
     * Palautetaan taulukko merkkijonona erottimella eroteltuna.
     * Lopussa ei ylimääräistä erotinta.
     * Toteutus if lausella 1. erottimen välttämiseksi.
     * @param taulukko joka palautetaan jonona
     * @param erotin millä jonolla erotellaan
     * @return taulukko merkkijonona erottimella eroteltuna
     * @example
     * <pre name="test">
     *   int[] t = {1,2,13,4};
     *   jonoksi3(t,",") === "1,2,13,4";
     * </pre>
     */
    public static String jonoksi3(int[] taulukko,String erotin) {
        StringBuilder tulos = new StringBuilder();
        for (int  i=0; i<taulukko.length; i++) {
            if ( i > 0 ) tulos.append(erotin);
            tulos.append(taulukko[i]);
        }
        return tulos.toString();
    }


    /**
     * Palautetaan taulukko merkkijonona erottimella eroteltuna.
     * Lopussa ei ylimääräistä erotinta.
     * Toteutus lisäämällä erotin loppuun ja palauttamalla osajono.
     * @param taulukko joka palautetaan jonona
     * @param erotin millä jonolla erotellaan
     * @return taulukko merkkijonona erottimella eroteltuna
     * @example
     * <pre name="test">
     *   int[] t = {1,2,13,4};
     *   jonoksi4(t,",") === "1,2,13,4";
     * </pre>
     */
    public static String jonoksi4(int[] taulukko,String erotin) {
        StringBuilder tulos = new StringBuilder();
        if ( taulukko.length == 0 ) return "";
        for (int  i=0; i<taulukko.length; i++) {
            tulos.append(erotin);
            tulos.append(taulukko[i]);
        }
        return tulos.substring(1,erotin.length());
    }


    /**
     * Palautetaan taulukko merkkijonona erottimella eroteltuna.
     * Lopussa ei ylimääräistä erotinta.
     * Edellinen toteutus foreach-silmukalla.
     * @param taulukko joka palautetaan jonona
     * @param erotin millä jonolla erotellaan
     * @return taulukko merkkijonona erottimella eroteltuna
     * @example
     * <pre name="test">
     *   int[] t = {1,2,13,4};
     *   jonoksi5(t,",") === "1,2,13,4";
     * </pre>
     */
    public static String jonoksi5(int[] taulukko,String erotin) {
        StringBuilder tulos = new StringBuilder();
        if ( taulukko.length == 0 ) return "";
        for (int luku: taulukko) {
            tulos.append(erotin);
            tulos.append(luku);
        }
        return tulos.substring(erotin.length());
    }


    /**
     * Palautetaan taulukko merkkijonona erottimella eroteltuna.
     * Lopussa ei ylimääräistä erotinta.
     * Toteutus tyhmästi String +=
     * @param taulukko joka palautetaan jonona
     * @param erotin millä jonolla erotellaan
     * @return taulukko merkkijonona erottimella eroteltuna
     * @example
     * <pre name="test">
     *   int[] t = {1,2,13,4};
     *   jonoksiString(t,",") === "1,2,13,4";
     * </pre>
     */
    public static String jonoksiString(int[] taulukko,String erotin) {
        String tulos = "";
        String ero = "";
        for (int  luku : taulukko) {
            tulos += ero + luku;
            ero = erotin;
        }
        return tulos;
    }




    private static int[] alusta(int koko) {
        int[] luvut = new int[koko];
        for (int i=0; i<luvut.length; i++)
            luvut[i] = i;
        return luvut;
    }



    @SuppressWarnings("javadoc")
    public static long alkuaika() {
        System.gc();
        return System.nanoTime();

    }


    @SuppressWarnings("javadoc")
    public static void tulos(long startTime, String jonona, String testi) {
        long loppuaika = (System.nanoTime()-startTime);
        System.out.printf("%-20s pituus on %10d, ", testi, jonona.length());
        System.out.printf("aika = %5.2f\n", loppuaika/1e9);
    }


    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        final int KOKO  =  100000;
        final int KOKO2 = KOKO*50;

        int[] luvut = alusta(KOKO);
        int[] luvut2 = alusta(KOKO2);

        // seuraavien ottaminen pois kommenteista vaikuttaa tuloksiin
        // String jonona = jonoksi(luvut2, ",");
        // System.out.printf("Pituus on %10d\n", jonona.length());


        tulos(alkuaika(), jonoksi(luvut2, ",") ,  "jonoksi");
        tulos(alkuaika(), jonoksi(luvut2, ",") ,  "jonoksi");
        tulos(alkuaika(), jonoksi(luvut2, ",") ,  "jonoksi");
        tulos(alkuaika(), jonoksi(luvut2, ",") ,  "jonoksi");
        tulos(alkuaika(), jonoksi(luvut2, ",") ,  "jonoksi");

        for (int i=0; i<5; i++) {
            tulos(alkuaika(), jonoksi(luvut2, ",") ,  "jonoksi");
            tulos(alkuaika(), jonoksi2(luvut2, ","),  "jonoksi2");
            tulos(alkuaika(), jonoksi3(luvut2, ","),  "jonoksi3");
            tulos(alkuaika(), jonoksi4(luvut2, ","),  "jonoksi4");
            tulos(alkuaika(), jonoksi5(luvut2, ",") , "jonoksi5");
        }
        tulos(alkuaika(), jonoksi(luvut, ",", 7), "jonoksi n /50");
        tulos(alkuaika(), jonoksiString(luvut, ",") , "jonoksiString /50");
    }
}