package luento21;

import java.awt.BorderLayout;
import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.UIManager;

/**
 * Malli siit millaisia erilaisia CallBack-toteutuksia voi olla Javassa
 * @author vesal
 * @version 17.3.2013
 */
public class FrameMalliKutsuista extends JFrame {

    private static final long serialVersionUID = 1L;
    private JPanel contentPane;
    private final JLabel labelMessage = new JLabel("");
    private final JPanel panelButtons = new JPanel();
    private final JButton buttonNimettyUlko = new JButton("Nimetty ulko");
    private final JButton buttonNimettySisa = new JButton("Nimetty sis\u00E4");
    private final JButton buttonNimetonSisa = new JButton("Nimetn sis\u00E4");
    private final JButton buttonSamaOlio1 = new JButton("Sama olio 1");
    private final JButton buttonSamaOlio2 = new JButton("Sama olio 2");


    /**
     * Launch the application.
     * @param args ei kytss
     */
    public static void main(String[] args) {
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (Throwable e) {
            e.printStackTrace();
        }
        EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                try {
                    FrameMalliKutsuista frame = new FrameMalliKutsuista();
                    frame.setVisible(true);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });
    }


    /**
     * Create the frame.
     */
    public FrameMalliKutsuista() {
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setBounds(100, 100, 389, 125);
        contentPane = new JPanel();
        contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
        contentPane.setLayout(new BorderLayout(0, 0));
        setContentPane(contentPane);
        
        contentPane.add(labelMessage, BorderLayout.SOUTH);
        
        contentPane.add(panelButtons, BorderLayout.CENTER);
        buttonNimettyUlko.addActionListener(new NappulaPainettuUlko(this));
        buttonNimettyUlko.addMouseListener(new HiiriUlko(this));
        buttonNimettySisa.addActionListener(new NappulaPainettuSisa());
        buttonNimettySisa.addMouseListener(new HiiriSisa());
        
        buttonNimetonSisa.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                setMessage("Nappi",e.getSource());
            }
        });
        buttonNimetonSisa.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseExited(MouseEvent e) {
                setMessage("Hiiri pois",e.getSource());
            }
        });

        buttonSamaOlio1.addMouseListener(samaHiiri);
        buttonSamaOlio1.addActionListener(samaNappi);

        buttonSamaOlio2.addMouseListener(samaHiiri);
        buttonSamaOlio2.addActionListener(samaNappi);
        
        panelButtons.add(buttonNimettyUlko);
        panelButtons.add(buttonNimettySisa);
        panelButtons.add(buttonNimetonSisa);
        
        panelButtons.add(buttonSamaOlio1);
        panelButtons.add(buttonSamaOlio2);
    }


    /**
     * @param s Jono joka tulostetaan alkuun
     * @param obj olio, josta teksti otetaan
     */
    public void setMessage(String s,Object obj) {
        if ( !(obj instanceof JButton) ) return;
        JButton painettu = (JButton)obj;
        labelMessage.setText(s + ": " +painettu.getText());
    }


    /**
     * Sisluokka ksittelemn nappulan painamista
     */
    public class NappulaPainettuSisa implements ActionListener {
        @Override
        public void actionPerformed(ActionEvent e) {
            setMessage("Nappi",e.getSource());
        }
    }
        

    /**
     * Sisluokka, jossa toteutetaan vaan muutama hiiren tapahtumista
     */
    public class HiiriSisa extends MouseAdapter {
        @Override
        public void mouseExited(MouseEvent e) {
            setMessage("Hiiri pois",e.getSource());
        }
    }

    // Ksitelijattribuuttiolioita eri tavoin tehtyn
    
    /** ksittelijolio joka luotu nimettmst sisluokasta */
    protected MouseAdapter samaHiiri = new MouseAdapter() {
        @Override
        public void mouseExited(MouseEvent e) {
            setMessage("Hiiri pois sama",e.getSource());
        }
    };

    /** ksittelijolio joka luotu sisluokasta */
    protected MouseAdapter samaHiiri2 = new HiiriSisa();
    
    /** ksittelijolio joka luotu ulkoluokasta */
    protected MouseListener samaHiiri3 = new HiiriUlko(this);
    
    /** ksittelijolio joka luotu ulkoluokasta */
    private ActionListener samaNappi = new NappulaPainettuUlko(this);

}