// Esimerkki STL:n algoritmien kytst
#include <iostream>
#include <algorithm>
#include <iterator>
using namespace std;

void tulosta_alkio(const int &alkio)
{
    cout << alkio << ' ';
}

class iotaGen {  // Apuluokka lukujonojen muodostamiseksi
    int current;
    int step;
public:
    iotaGen(int start=0, int istep=1) : current(start), step(istep) {}
    int operator () () { int v=current; current += step; return v; }
};

int nelio(int n) { return n*n; }

#define VIIVA "------------------------------------------------------------\n"
/****************************************************************************/
int mainFor()
{
    ostream_iterator<int> output(cout," "); // Uusi luokka tulostamista varten

    cout << VIIVA;

    int luvut[6] = { 23, 45, 12, 7, 9, 2 };
    for_each(luvut,luvut+6,tulosta_alkio); cout << endl;// 23 45 12 7 9 2
    for_each(luvut,luvut+6,[](int a){cout << a << " ";}); cout << endl;// 23 45 12 7 9 2

    cout << "Suurin: " << *max_element(luvut,luvut+6) << endl; // Suurin: 45

    fill(luvut+3,luvut+6,175);
    copy(luvut,luvut+6,output); cout << endl;           // 23 45 12 175 175 175

    int *p = find(luvut,luvut+6,45);
    if ( p != luvut+6 ) cout << "Lytyi: " << *p << endl;          // Lytyi: 45
    p = find(luvut,luvut+6,46);
    if ( p == luvut+6 ) cout << "Ei lytynyt!" << endl; // Ei lytynyt!

    generate(luvut,luvut+6,iotaGen(10,5));
    for_each(luvut,luvut+6,tulosta_alkio); cout << endl;// 10 15 20 25 30 35

    int luku=12;
    generate(luvut,luvut+6,[&](){int n=luku; luku+=6; return n; });
    for_each(luvut,luvut+6,tulosta_alkio); cout << endl;// 12 18 24 30 36 42

    reverse(luvut,luvut+6);
    copy(luvut,luvut+6,output);  cout << endl;          // 42 36 30 24 18 12

    sort(luvut,luvut+6);
    copy(luvut,luvut+6,output);  cout << endl;          // 12 18 24 30 36 42

    transform(luvut,luvut+6,luvut,nelio);
    // Tekee jokaiselle alkiolle luvut[i]=nelio(luvut[i])
    copy(luvut,luvut+6,output);  cout << endl;          // 144 324 576 900 1296 1764

    transform(luvut,luvut+6,luvut,[](int n){ return n*n;});
    // Tekee jokaiselle alkiolle luvut[i]=nelio(luvut[i])
    copy(luvut,luvut+6,output);  cout << endl;          // 20736 104976 331776 810000 1679616 3111696

    return 0;
}



